package com.jiuqi.db.impl;

import com.jiuqi.db.DBFunction;
import com.jiuqi.util.DateUtil;
import java.util.Date;

public class SQLServerDBFunction extends DBFunction {
   private static final String STR_LINK_SYMBOL = "+";
   private static final String FUNC_NAME_CEILING = "CEILING";
   private static final String FUNC_NAME_LN = "LOG";
   private static final String FUNC_NAME_LOG10 = "LOG10";
   private static final String FUNC_NAME_CHR = "CHAR";
   private static final String FUNC_NAME_POS = "CHARINDEX";
   private static final String FUNC_NAME_LEFT = "LEFT";
   private static final String FUNC_NAME_RIGHT = "RIGHT";
   private static final String FUNC_NAME_SUBSTR = "SUBSTRING";
   private static final String FUNC_NAME_LEN = "DATALENGTH";
   private static final String FUNC_NAME_MOD = "%";
   private static final String FUNC_NAME_STR = "CAST";
   private static final String FUNC_NAME_VAL = "CAST";

   public String strLinkSymbol() {
      return "+";
   }

   public boolean supportEmptyString() {
      return true;
   }

   public String ceiling(String numeric_expression) {
      return this.format("CEILING", numeric_expression);
   }

   public String ln(String numeric_expression) {
      return this.format("LOG", numeric_expression);
   }

   public String log10(String numeric_expression) {
      return this.format("LOG10", numeric_expression);
   }

   public String mod(String numeric_expression1, String numeric_expression2) {
      return this.formatmidopt(numeric_expression1, "%", numeric_expression2);
   }

   public String chr(String int_expression) {
      return this.format("CHAR", int_expression);
   }

   public String pos(String substr_expression, String str_expression) {
      return this.format("CHARINDEX", substr_expression, str_expression);
   }

   public String left(String str_expression, String length_expression) {
      return this.format("LEFT", str_expression, length_expression);
   }

   public String right(String str_expression, String length_expression) {
      return this.format("RIGHT", str_expression, length_expression);
   }

   public String str(String numeric_expression) {
      return this.format("CAST", numeric_expression + " AS VARCHAR(50)");
   }

   public String substr(String str_expression, String from_expression, String length_expression) {
      return this.format("SUBSTRING", str_expression, from_expression, length_expression);
   }

   public String len(String str_expression) {
      return this.format("DATALENGTH", str_expression);
   }

   public String val(String str_expression) {
      return this.format("CAST", str_expression + " AS FLOAT");
   }

   public String date(Date dateVal) {
      return "'" + DateUtil.convertDateToString1(dateVal) + "'";
   }
}
